# #
# Software subject to following license(s):
#   Apache 2 License (http://www.opensource.org/licenses/apache2.0)
#   Copyright (c) Responsible Organization
#

# #
# Current developer(s):
#   Luis Fernando Muñoz Mejías <Luis.Munoz@UGent.be>
#

# #
# Author(s): Germán Cancio, Marco Emilio Poleggi, Michel Jouvin, Jan Iven, Mark R. Bannister, Jindrich Novy, James Adams
#


declaration template components/spma/yumng/schema;

include 'components/spma/schema';
include 'components/spma/schema-common-yum';

type SOFTWARE_GROUP = {
    "default" : boolean = true
    "mandatory" : boolean = true
    "optional" : boolean = false
    "names" : string[] = list() with {
        if (length(SELF) > 0) deprecated(0, 'Support for YUM groups will be removed in a future release.');
        true;
    }
};

type component_spma_yumng = {
    include structure_component
    include component_spma_common
    include component_spma_common_yum
    "excludes" ? string[] # packages to be excluded from metadata
    "quattor_os_file" ? string # file to write quattor_os_release as confirmation of successful YUM spma pass
    "quattor_os_release" ? string # string to write to quattor_os_file
    "run" ? legacy_binary_affirmation_string # Run the SPMA after configuring it
    "userpkgs" ? legacy_binary_affirmation_string # Allow user packages
    "whitelist" ? string[] # packages not shipped by repositories but generated by 3rd party installer
    "yumconf" ? string # /etc/yum.conf YUM configuration
};

bind "/software/components/spma" = component_spma_yumng;
bind "/software/groups" = SOFTWARE_GROUP;
